'use strict';
var objectPatternB = require('nodes');
var nodes = objectPatternB.nodes;
var objectPatternA = require('./id');
var getUniqueName = objectPatternA.getUniqueName;
var objectPattern = require('./string');
var express = objectPattern.express;
exports.getSelfId = function (node) {
  if (!node.selfId) {
    var selfName = getUniqueName(node, 'self');
    var declaration = express('var ' + selfName + ' = this');
    var id = declaration.declarations[0].id;
    var body = nodes.Function.test(node) ? node.body.body : node.body;
    body.unshift(declaration);
    node.selfId = id;
  }
  return node.selfId;
};